﻿
Enumeration
  #DFMFile
  #DFMCodeFile
  #File
  #DFMInsFile
EndEnumeration

XIncludeFile "ZLIBmodule.pb"

;{ bits
Macro SetBit(Var, Bit) ; 
  Var | (Bit)
EndMacro 
Macro ClearBit(Var, Bit) ;
  Var & (~(Bit))
EndMacro 
Macro TestBit(Var, Bit)
  Bool(Var & (Bit))
EndMacro
Macro NumToBit(Num) ; 
  (1<<(Num))
EndMacro
Macro GetBits(Var, StartPos, EndPos)
  ((Var>>(StartPos))&(NumToBit((EndPos)-(StartPos)+1)-1))
EndMacro
;}

Structure gemsinstp
  raw.a[40] ; instrument data
EndStructure
Global Dim GEMSInstrPack.gemsinstp(0)

Structure modstruct2
  moddur.w
  modspd.w
EndStructure
Structure modstruct
  Array modperiod.modstruct2(0)
EndStructure
Global Dim GEMSModulations.modstruct(0)
; modulation have counter and speed. 
; that data can pepeated a few times
; for create some bend of frequency of notes

Structure gemsinstarray
  num.a
  stereo.a
  newnum.a
EndStructure
Global Dim DFMCfgInstrumList.gemsinstarray(0)

;//PATTERNS Data
;Repeat this SYSTEM_TOTAL_CHANNELS times
;	1 Byte: CHANNEL_EFFECTS_COLUMNS_COUNT
;	Repeat this TOTAL_ROWS_IN_PATTERN_MATRIX times
;		Repeat this TOTAL_ROWS_PER_PATTERN times
;			2 Bytes: Note For this index
;			2 Bytes: Octave For this index
;			//Note values:
	;		//01 C#
	;		//02 D-
	;		//03 D#
	;		//04 E-
;			//05 F-
;			//06 F#
;			//07 G-
	;		//08 G#
	;		//09 A-
	;		//10 A#
	;		//11 B-
	;		//12 C-
;
;			//Special cases:
;			//Note = 0 And octave = 0 means empty.
;			//Note = 100 means NOTE OFF, no matter what is inside the octave value.
;
;			2 Bytes: Volume For this index (-1 = Empty)
;			Repeat this CHANNEL_EFFECTS_COLUMNS_COUNT times
;				2 Bytes: Effect Code For this index (-1 = Empty)
;				2 Bytes: Effect Value For this index (-1 = Empty)
;			2 Bytes: Instrument For this index (-1 = Empty)
Structure patternstr
  ;	2 Bytes: Note For this index
  ;	2 Bytes: Octave For this index
  note.w
  octv.w
  
  ; 2 Bytes: Volume For this index (-1 = Empty)
  volm.w
  
  ; Repeat this CHANNEL_EFFECTS_COLUMNS_COUNT times
  ;		2 Bytes: Effect Code For this index (-1 = Empty)
  ;		2 Bytes: Effect Value For this index (-1 = Empty)
  efcd.w
  efvl.w
  
  ; 2 Bytes: Instrument For this index (-1 = Empty)
  inst.w
  
  stereo.a
  bendspeed.w
  
  duration.u
  delay.u

EndStructure
Structure patternstr2
  channel.patternstr[11]
EndStructure
Global Dim FullPattern.patternstr2(0)

; it have some formula, but i dont know it, so i have tables
Global Dim NTSCBPMTable.u($16) ;{
NTSCBPMTable(01) = 450
NTSCBPMTable(02) = 300
NTSCBPMTable(03) = 225
NTSCBPMTable(04) = 180
NTSCBPMTable(05) = 150
NTSCBPMTable(06) = 128;.57
NTSCBPMTable(07) = 112;.50
NTSCBPMTable(08) = 100
NTSCBPMTable(09) = 90
NTSCBPMTable($0A) = 81;.82
NTSCBPMTable($0B) = 75
NTSCBPMTable($0C) = 69;.23
NTSCBPMTable($0D) = 64;.29
NTSCBPMTable($0E) = 60
NTSCBPMTable($0F) = 56;.25
NTSCBPMTable($10) = 52;.94
NTSCBPMTable($11) = 50 
NTSCBPMTable($12) = 47;.37
NTSCBPMTable($13) = 45
NTSCBPMTable($14) = 42;.86
NTSCBPMTable($15) = 40;.91
NTSCBPMTable($16) = 39;.13
;}
Global Dim PALBPMTable.u($16) ;{
PALBPMTable(01) = 375
PALBPMTable(02) = 250
PALBPMTable(03) = 187;.50
PALBPMTable(04) = 150
PALBPMTable(05) = 125
PALBPMTable(06) = 107;.14
PALBPMTable(07) = 93;.75
PALBPMTable(08) = 83;.33
PALBPMTable(09) = 75
PALBPMTable($0A) = 68;.18
PALBPMTable($0B) = 62;.50
PALBPMTable($0C) = 57;.69
PALBPMTable($0D) = 53;.57
PALBPMTable($0E) = 50
PALBPMTable($0F) = 46;.88
PALBPMTable($10) = 44;.12
PALBPMTable($11) = 41;.67 
PALBPMTable($12) = 39;.47
PALBPMTable($13) = 37;.50
PALBPMTable($14) = 35;.71
PALBPMTable($15) = 34;.09
PALBPMTable($16) = 32;.61
;}
Procedure.u GetDMFbpm(NTSC, bpm1, bpm2)
  
  retbpm.u = 30 ; default
  
  num.a = (bpm1 - 1) + bpm2
  
  If num < $17
    If NTSC
      retbpm = NTSCBPMTable(num)
    Else
      retbpm = PALBPMTable(num)
    EndIf
  EndIf
  
  ProcedureReturn retbpm
  
EndProcedure 

Procedure.s GetDMFNote(value.a)
  
  ret$ = ""
  
  Select value
    Case 0
      ret$ = "C-"
    Case 1
      ret$ = "C#"
    Case 2
      ret$ = "D-"
    Case 3
      ret$ = "D#"
    Case 4
      ret$ = "E-"
    Case 5
      ret$ = "F-"
    Case 6
      ret$ = "F#"
    Case 7
      ret$ = "G-"
    Case 8
      ret$ = "G#"
    Case 9
      ret$ = "A-"
    Case 10
      ret$ = "A#"
    Case 11
      ret$ = "B-"
    Case 12
      ret$ = "C-"
  EndSelect  
  
  ProcedureReturn ret$
  
EndProcedure

Procedure.u GEMSInstrumentsStore(num.a, stereo.a, IstrQuant.a)
  
  ret.u
  bingo.a
  i.w
  size.u
  
  size = ArraySize(DFMCfgInstrumList())
  
  If size = 0
    ; it is first instrument. just add it into array
    ReDim DFMCfgInstrumList(1)
    DFMCfgInstrumList(1)\num = num
    ; stereo checks
    If stereo
      DFMCfgInstrumList(1)\stereo = stereo
      DFMCfgInstrumList(1)\newnum = IstrQuant
      ret = IstrQuant
      IstrQuant + 1
    Else
      DFMCfgInstrumList(1)\newnum = num
      ret = num
    EndIf    
  Else
    ; search in a array
    For i = 1 To size
      If DFMCfgInstrumList(i)\num = num And DFMCfgInstrumList(i)\stereo = stereo
        ret = DFMCfgInstrumList(i)\newnum
        bingo = 1
        Break
      EndIf
    Next
    
    If bingo = 0
      ; old array no have it
      ; inc array
      size + 1 
      ReDim DFMCfgInstrumList(size)
      DFMCfgInstrumList(size)\num = num
      ; stereo checks
      If stereo
        DFMCfgInstrumList(size)\stereo = stereo
        DFMCfgInstrumList(size)\newnum = IstrQuant
        ret = IstrQuant
        IstrQuant + 1
      Else
        DFMCfgInstrumList(size)\newnum = num
        ret = num
      EndIf 
      
    EndIf
    
  EndIf
    
  ret = IstrQuant << 8 + ret
  
  ProcedureReturn ret
  
EndProcedure

Procedure.u GEMSGetModulation(moddur.w, modspd.w, moddur2.w=0, modspd2.w=0, moddur3.w=0, modspd3.w=0, moddur4.w=0, modspd4.w=0, moddur5.w=0, modspd5.w=0)
  
  ; porno
  
  ret.u
  bingo.a
  i.w
  size.u
  sz.u
  
  size = ArraySize(GEMSModulations())
  If size = 0
    ReDim GEMSModulations(1)
    ReDim GEMSModulations(1)\modperiod(1)
    GEMSModulations(1)\modperiod(1)\moddur = moddur
    GEMSModulations(1)\modperiod(1)\modspd = modspd
    
    If moddur2
        ReDim GEMSModulations(1)\modperiod(2)
        GEMSModulations(1)\modperiod(2)\moddur = moddur2
        GEMSModulations(1)\modperiod(2)\modspd = modspd2
        If moddur3
          ReDim GEMSModulations(1)\modperiod(3)
          GEMSModulations(1)\modperiod(3)\moddur = moddur3
          GEMSModulations(1)\modperiod(3)\modspd = modspd3
          If moddur4
            ReDim GEMSModulations(1)\modperiod(4)
            GEMSModulations(1)\modperiod(4)\moddur = moddur4
            GEMSModulations(1)\modperiod(4)\modspd = modspd4
            If moddur5
              ReDim GEMSModulations(1)\modperiod(5)
              GEMSModulations(1)\modperiod(5)\moddur = moddur5
              GEMSModulations(1)\modperiod(5)\modspd = modspd5
            EndIf
          EndIf
        EndIf
    EndIf
    
    ret = 1
  Else
    For i = 1 To size
      sz = ArraySize(GEMSModulations(i)\modperiod())
      Select sz
        Case 1 
          If GEMSModulations(i)\modperiod(1)\moddur = moddur And 
             GEMSModulations(i)\modperiod(1)\modspd = modspd
            ret = i
            bingo = 1
            Break
          EndIf
        Case 2
          If GEMSModulations(i)\modperiod(1)\moddur = moddur And 
             GEMSModulations(i)\modperiod(1)\modspd = modspd And
             GEMSModulations(i)\modperiod(2)\moddur = moddur2 And 
             GEMSModulations(i)\modperiod(2)\modspd = modspd2 
            ret = i
            bingo = 1
            Break
          EndIf
        Case 3
          If GEMSModulations(i)\modperiod(1)\moddur = moddur And 
             GEMSModulations(i)\modperiod(1)\modspd = modspd And
             GEMSModulations(i)\modperiod(2)\moddur = moddur2 And 
             GEMSModulations(i)\modperiod(2)\modspd = modspd2 And
             GEMSModulations(i)\modperiod(3)\moddur = moddur3 And 
             GEMSModulations(i)\modperiod(3)\modspd = modspd3  
            ret = i
            bingo = 1
            Break
          EndIf
        Case 4
          If GEMSModulations(i)\modperiod(1)\moddur = moddur And 
             GEMSModulations(i)\modperiod(1)\modspd = modspd And
             GEMSModulations(i)\modperiod(2)\moddur = moddur2 And 
             GEMSModulations(i)\modperiod(2)\modspd = modspd2 And
             GEMSModulations(i)\modperiod(3)\moddur = moddur3 And 
             GEMSModulations(i)\modperiod(3)\modspd = modspd3 And
             GEMSModulations(i)\modperiod(4)\moddur = moddur4 And 
             GEMSModulations(i)\modperiod(4)\modspd = modspd4  
            ret = i
            bingo = 1
            Break
          EndIf
        Case 5
          If GEMSModulations(i)\modperiod(1)\moddur = moddur And 
             GEMSModulations(i)\modperiod(1)\modspd = modspd And
             GEMSModulations(i)\modperiod(2)\moddur = moddur2 And 
             GEMSModulations(i)\modperiod(2)\modspd = modspd2 And
             GEMSModulations(i)\modperiod(3)\moddur = moddur3 And 
             GEMSModulations(i)\modperiod(3)\modspd = modspd3 And
             GEMSModulations(i)\modperiod(4)\moddur = moddur4 And 
             GEMSModulations(i)\modperiod(4)\modspd = modspd4 And
             GEMSModulations(i)\modperiod(5)\moddur = moddur5 And 
             GEMSModulations(i)\modperiod(5)\modspd = modspd5    
            ret = i
            bingo = 1
            Break
          EndIf
      EndSelect
    Next
    
    If bingo = 0
      size + 1
      ReDim GEMSModulations(size)
      ReDim GEMSModulations(size)\modperiod(1)
      GEMSModulations(size)\modperiod(1)\moddur = moddur
      GEMSModulations(size)\modperiod(1)\modspd = modspd
      
      If moddur2
        ReDim GEMSModulations(size)\modperiod(2)
        GEMSModulations(size)\modperiod(2)\moddur = moddur2
        GEMSModulations(size)\modperiod(2)\modspd = modspd2
        If moddur3
          ReDim GEMSModulations(size)\modperiod(3)
          GEMSModulations(size)\modperiod(3)\moddur = moddur3
          GEMSModulations(size)\modperiod(3)\modspd = modspd3
          If moddur4
            ReDim GEMSModulations(size)\modperiod(4)
            GEMSModulations(size)\modperiod(4)\moddur = moddur4
            GEMSModulations(size)\modperiod(4)\modspd = modspd4
            If moddur5
              ReDim GEMSModulations(size)\modperiod(5)
              GEMSModulations(size)\modperiod(5)\moddur = moddur5
              GEMSModulations(size)\modperiod(5)\modspd = modspd5
            EndIf
          EndIf
        EndIf
      EndIf
      
      ret = size
    EndIf
  EndIf
  
  

  ProcedureReturn ret
  
EndProcedure






;- INPUT Filename 
deflemaskinput$ = "DemoEffects.dmf"
;- OUTPUT folder
gemssaveto$ = "GEMS\"



               If gemssaveto$ And deflemaskinput$
                 
                 EnableFileWrite = 1
                 
                 ;{ clear
                 If *packeddfmfilemem
                   FreeMemory(*packeddfmfilemem)
                   *packeddfmfilemem = 0
                 EndIf
                 If *unpdfmfilemem
                   FreeMemory(*unpdfmfilemem)
                   *unpdfmfilemem = 0
                 EndIf
                 error.a = 0
                 LOOPMARKER = -1
                 ReDim GEMSInstrPack(0)
                 ReDim GEMSModulations(0)
                 ;}
                 
                 ;{ read file
                 If ReadFile(#DFMFile, deflemaskinput$)
                   ; into image
                   nLength = Lof(#DFMFile)
                   *packeddfmfilemem = AllocateMemory(nLength)
                   If *packeddfmfilemem
                     ReadData(#DFMFile, *packeddfmfilemem, nLength)
                   Else
                     MessageRequester("error", "problem with a working with memory")
                   EndIf
                   CloseFile(#DFMFile)
                 EndIf
                 ;}
                 
                 If *packeddfmfilemem
                   ;{ unpack if it is packed
                   *unpdfmfilemem = Inflate_Payload(*packeddfmfilemem, nLength, 15)
                   If *unpdfmfilemem
                     ; packed
                     markernum = *unpdfmfilemem
                   Else
                     ; unpacked
                     markernum = *packeddfmfilemem
                   EndIf
                   ;}
                   
                   ;{ checks and parse
                   If PeekS(markernum, 16, #PB_Ascii) = ".DelekDefleMask." 

                     ; jump
                     markernum + 16
                     
                     markernum + 1
                     console = PeekA(markernum)

                     Select console 
                       ;{
                       ; sega 10 or sega 13
                       Case $42 ; 13
                         channelsnum        = 13
                         dmsamplechannelnum = 9
                         dmnoisechannelnum  = 13
                         dmfirstpsgchannel  = dmsamplechannelnum + 1
                       Case $02 ; 10
                         channelsnum        = 10
                         dmsamplechannelnum = 6
                         dmnoisechannelnum  = 10  
                         dmfirstpsgchannel  = dmsamplechannelnum + 1
                       Default
                         MessageRequester("error", "it is not supported type of Deflemask's file. it need to be sega 10. or sega 13 - but not recommended that sega 13.")
                         error = 1
                       ;}    
                     EndSelect
                     
                     If error = 0
                       ; game console is correct
                       
                       markernum + 1
                       namesize  = PeekA(markernum)
                       markernum + 1
                       
                       markernum + namesize
                       autorsize = PeekA(markernum)
                       markernum + 1
                       
                       markernum + autorsize
                       ;Debug "Highlight A " + Str(PeekA(markernum))
                       markernum + 1
                       ;Debug "Highlight B " + Str(PeekA(markernum))
                       markernum + 1
                       
                       
                       ;Debug "Time Base " + Str(PeekA(markernum))
                       markernum + 1
                       bpm1.a = PeekA(markernum)
                       ;Debug "Tick Time 1 " + Str(PeekA(markernum))
                       markernum + 1	
                       bpm2.a = PeekA(markernum)
                       ;Debug "Tick Time 2 " + Str(PeekA(markernum))
                       markernum + 1
                       NTSC.a = PeekA(markernum)
                       dmftorrrbpm.u = GetDMFbpm(NTSC, bpm1, bpm2)
                       ;Debug "Frames Mode (0 = PAL, 1 = NTSC) " + Str(PeekA(markernum))
                       markernum + 1
                       ;Debug "Using Custom HZ " + Str(PeekA(markernum))
                       markernum + 1
                       ;Debug "Custom HZ value 1 " + Str(PeekA(markernum))
                       markernum + 1
                       ;Debug "Custom HZ value 2 " + Str(PeekA(markernum))
                       markernum + 1
                       ;Debug "Custom HZ value 3 " + Str(PeekA(markernum))
                       markernum + 1
                       
                       ; size of one pattern
                       TOTALROWSPERP = PeekL(markernum)
                       ;Debug "TOTAL_ROWS_PER_PATTERN " + Str(TOTALROWSPERP)
                       markernum + 4
                       ; count pattens
                       TROWSINPATTERNMATRIX = PeekA(markernum)
                       

                       ; jump to the end of "matrix"
                       markernum + 1 + (TROWSINPATTERNMATRIX * channelsnum);
                       
                       ; count instruments
                       IstrQuant = PeekA(markernum)
                       markernum + 1
                       
                       For ins = 1 To IstrQuant 
                         ;{ instrument
                         ;{ name and creator
                         instrnamesize = PeekA(markernum)
                         markernum + 1
                         markernum + instrnamesize
                         ; type
                         instrtype = PeekA(markernum)
                         markernum + 1
                         ;}
                         
                         ; increase array with instruments
                         ReDim GEMSInstrPack(ins)
                         
                         If instrtype = 1 ;{ FM
                           
                           ; ch3 special mode
                           GEMSInstrPack(ins)\raw[30] = $1F
                           GEMSInstrPack(ins)\raw[31] = $FF
                           GEMSInstrPack(ins)\raw[32] = $1F
                           GEMSInstrPack(ins)\raw[33] = $FF
                           GEMSInstrPack(ins)\raw[34] = $1F
                           GEMSInstrPack(ins)\raw[35] = $FF
                           GEMSInstrPack(ins)\raw[36] = $1F
                           GEMSInstrPack(ins)\raw[37] = $FF
                           
                           ; key on param
                           GEMSInstrPack(ins)\raw[38] = $0F
          
                           ;|??fffaaa| - Feedback, Algorithm    (raw register B0)
                           alg    = PeekA(markernum) : markernum + 1
                           fb     = PeekA(markernum) : markernum + 1
                           fb << 3
                           Number = fb + alg                           
                           GEMSInstrPack(ins)\raw[4] = Number
          
                           ;|lraa?fff| - Left/Right, AMS, FMS   (raw register B4)
                           fms    = PeekA(markernum) : markernum + 1
                           ams    = PeekA(markernum) : markernum + 1
                           Number = %11000000 + (ams << 4) + fms          
                           GEMSInstrPack(ins)\raw[5] = Number

          
                           For i = 1 To 4 ;{ fill operators
            
                             ;|?dddmmmm| - Detune, Multiply       (raw register 30)
                             ;|?ttttttt| - TLevel                 (raw register 40)
                             ;|rr?aaaaa| - Rate Scale, Attack     (raw register 50)
                             ;|a??ddddd| - AM, Decay              (raw register 60)
                             ;|???sssss| - Sustain                (raw register 70)
                             ;|ssssrrrr| - Sustain Level, Release (raw register 80)
            
                             ; AM
                             am       = PeekA(markernum) : markernum + 1
            
                             ; Attack
                             attack   = PeekA(markernum) : markernum + 1
            
                             ; Decay
                             decay    = PeekA(markernum) : markernum + 1
            
                             ; Multiply
                             Multiply = PeekA(markernum) : markernum + 1
            
                             ; Release
                             Release  = PeekA(markernum) : markernum + 1
            
                             ; Sustain Level
                             SusLevel = PeekA(markernum) : markernum + 1
            
                             ; TLevel
                             TLevel   = PeekA(markernum) : markernum + 1
            
                             ; not used for GEMS? just jump                            
                             markernum + 1
            
                             ; Rate Scale
                             RateScal = PeekA(markernum) : markernum + 1
            
                             ; Detune
                             Detune   = PeekA(markernum) : markernum + 1
                             Select Detune
                               Case 0
                                 Detune = 7
                               Case 1
                                 Detune = 6
                               Case 2
                                 Detune = 5
                               Case 3
                                 Detune = 0
                               Case 4
                                 Detune = 1
                               Case 5
                                 Detune = 2
                               Case 6
                                 Detune = 3
                             EndSelect
            
                             ; Sustain
                             Sustain  = PeekA(markernum) : markernum + 1
            
                             ; SSG is not used by GEMS. just jump
                             markernum + 1
            
                             Select i
                               Case 1
                                 start = 6
                               Case 2
                                 start = 12
                               Case 3
                                 start = 18
                               Case 4
                                 start = 24
                             EndSelect
            
                             ; |?dddmmmm| - Detune, Multiply 
                             GEMSInstrPack(ins)\raw[start] = Detune << 4 + Multiply   
                             start + 1
                             ; |?ttttttt| - TLevel
                             GEMSInstrPack(ins)\raw[start] = TLevel
                             start + 1
                             ; |rr?aaaaa| - Rate Scale, Attack
                             GEMSInstrPack(ins)\raw[start] = RateScal << 6 + attack
                             start + 1
                             ; |a??ddddd| - AM, Decay
                             GEMSInstrPack(ins)\raw[start] = am << 7 + decay 
                             start + 1
                             ; |???sssss| - Sustain
                             GEMSInstrPack(ins)\raw[start] = Sustain
                             start + 1
                             ; |ssssrrrr| - Sustain Level, Release
                             GEMSInstrPack(ins)\raw[start] = SusLevel << 4 + Release
                             start + 1
            
                             ;}  
                           Next
                           ;}
                         Else             ;{ another types
          
				  ;//If INSTRUMENT MODE IS STANDARD ( = 0)
					  ;//If Not SYSTEM_GAMEBOY (Game Boy uses STD instruments but has internal ADSR Volume, do Not Read VOLUME Macro For it)
              ;//VOLUME Macro
              ;1 Byte: ENVELOPE_SIZE (0 - 127)
              VolMacrEnvSize.a = PeekA(markernum) : markernum + 1
              ;Debug "VolMacr Env Size " + Str(VolMacrEnvSize)
              ;ReDim DFMPSGInputData(VolMacrEnvSize)
              If VolMacrEnvSize > 0  
                ;{ PSG
                For i = 1 To VolMacrEnvSize
                  ENVVAL.l = PeekL(markernum) : markernum + 4
                  ;Debug "ENVELOPE_VALUE " + Str(ENVVAL) 
                  ;DFMPSGInputData(i) = ENVVAL
                Next
                LOOPPOS.b = PeekB(markernum) : markernum + 1
                ;Debug "LOOP_POSITION " + Str(LOOPPOS)
                
                ;PSGEditorWindow(1, ins-1, gemssaveto$, EnableFileWrite)
                ;}
              EndIf
              
              ;{ 
              ARPEGGIOMacro = PeekA(markernum) : markernum + 1
              ;Debug "ARPEGGIOMacro " + Str(ARPEGGIOMacro)
              If ARPEGGIOMacro > 0                
                For i = 1 To ARPEGGIOMacro
                  ;Debug "ENVELOPE_VALUE " + Str(PeekL(markernum)) 
                  markernum + 4
                Next
                ;Debug "LOOP_POSITION " + Str(PeekB(markernum)) 
                markernum + 1
              EndIf
              
              ;Debug "ARPEGGIO MODE " + Str(PeekA(markernum)) 
              markernum + 1
              
              DUTYNOISE = PeekA(markernum) : markernum + 1
              ;Debug "DUTYNOISE " + Str(DUTYNOISE)
              If DUTYNOISE > 0                
                For i = 1 To DUTYNOISE
                  ;Debug "ENVELOPE_VALUE " + Str(PeekL(markernum)) 
                  markernum + 4
                Next
                ;Debug "LOOP_POSITION " + Str(PeekB(markernum)) 
                markernum + 1
              EndIf
              
              WAVETABLE = PeekA(markernum) : markernum + 1
              ;Debug "WAVETABLE " + Str(WAVETABLE)
              If WAVETABLE > 0                
                For i = 1 To WAVETABLE
                  ;Debug "ENVELOPE_VALUE " + Str(PeekL(markernum)) 
                  markernum + 4
                Next
                ;Debug "LOOP_POSITION " + Str(PeekB(markernum)) 
                markernum + 1
              EndIf
              ;}
              
              ;{ spec
			        ;//PER SYSTEM Data
				        ;//If SYSTEM_C64
					          ;1 Byte: Triangle Wave Enabled
					          ;1 Byte: Saw Wave Enabled
					          ;1 Byte: Pulse Wave Enabled
					          ;1 Byte: Noise Wave Enabled
					          ;1 Byte: Attack
					          ;1 Byte: Decay
					          ;1 Byte: Sustain
					          ;1 Byte: Release
					          ;1 Byte: Pulse Width
					          ;1 Byte: Ring Modulation Enabled
					          ;1 Byte: Sync Modulation Enabled
					          ;1 Byte: To Filter
					          ;1 Byte: Volume Macro To Filter Cutoff Enabled
					          ;1 Byte: Use Filter Values From Instrument
					          ;//FILTER GLOBALS
					          ;1 Byte: Filter Resonance
					          ;1 Byte: Filter Cutoff
					          ;1 Byte: Filter High Pass
					          ;1 Byte: Filter Low Pass
					          ;1 Byte: Filter CH2 Off
				        ;//If SYSTEM_GAMEBOY
					          ;1 Byte: Envelope Volume
					          ;1 Byte: Envelope Direction
					          ;1 Byte: Envelope Length
                    ;1 Byte: Sound Length
              ;}
          ;}
                         EndIf
                         ;}
                       Next
                       
                       ;//WAVETABLES DATA 
                       ;{
                       WAVETABLES = PeekA(markernum)
                       ;Debug "WAVETABLES " + Str(WAVETABLES)
                       markernum + 1
      
                       If WAVETABLES > 0
                         For i = 1 To WAVETABLES
                           WAVETABLESIZE = PeekL(markernum) : markernum + 4
                           ;Debug "WAVETABLE_SIZE " + Str(WAVETABLESIZE)
                           For l = 1 To WAVETABLESIZE
                             ;Debug "Wavetable " + Str(PeekL(markernum)) 
                             markernum + 4
                           Next
                         Next
                       EndIf
                       ;}
                       
                       
                       ;//PATTERNS DATA      
                       MAINPARTCODE$ = ""
      
                       ReDim DFMCfgInstrumList(0)
                       ;Dim DFMCfgSampleList(0)
                       codechannums = 0
                       
                       ;{ reset old data
                       ReDim FullPattern(0)
                       ;}
                       
                       ; prepear array
                       ReDim FullPattern(TROWSINPATTERNMATRIX * TOTALROWSPERP)
        
                       ;Repeat this SYSTEM_TOTAL_CHANNELS times - 13
                       For chan = 1 To 6;channelsnum
                           
                           ;Debug "chan = " + Str(chan)
                           
                           ;1 Byte: CHANNEL_EFFECTS_COLUMNS_COUNT
                           CHANNELEFFECTSCOLUMNSCOUNT = PeekA(markernum)
                           markernum + 1
                           
                           ; reset params
                           dfmduration = 0
                           dfmdelay    = 0
                           oldnote     = 0
                           obinstr     = 0
                           oldinst     = 0
                           originst    = 0
                           oldoctv     = 0
                           oldvolm     = 0
                           obvolum     = 0
                           delmiss     = 0
                           lastdel     = 0
                           lastdur     = 0
                           sampleson   = 0
                           oldsmon     = 0
                           oldeffcod   = 0
                           oldeffval   = 0
                           modnote     = 0
                           modulation  = 0
                           oldnoteadd  = 0
                           oldduration = 0
                           oldvolmadd  = 0
                           objstereo   = 0
                           o3duration  = 0
                           
                           ;Repeat this TOTAL_ROWS_IN_PATTERN_MATRIX times
                           For matrix = 1 To TROWSINPATTERNMATRIX
                             
                             
                             matrind = (matrix - 1) * TOTALROWSPERP
                             
                             ;Repeat this TOTAL_ROWS_PER_PATTERN times
                             For patterns = 1 To TOTALROWSPERP    ;{
                               
                               ;2 Bytes: Note For this index
                               note = PeekU(markernum) : markernum + 2
                               
                               ;2 Bytes: Octave For this index
                               octv = PeekU(markernum) : markernum + 2
                               ;Debug "chan = " + Str(chan) + "; note = " + Str(note ) + "; octv = " + Str(octv) 
                               ; additional check, because...
                               ; С-4 can be as 0-4 and 12-3
                               If octv And note = 0
                                 octv - 1
                                 note = 12
                               EndIf
                               
                               ;2 Bytes: Volume For this index (-1 = Empty)
                               volm = PeekW(markernum) : markernum + 2
                               
                               If volm > 0 And note = 0 And oldnote <> 100
                                 ; case for fade off, fade in
                                 note = 200 ; mark, for making recount "delay"
                               EndIf
                               
                               
                               ;Repeat this CHANNEL_EFFECTS_COLUMNS_COUNT times
                               For chaneff = 1 To CHANNELEFFECTSCOLUMNSCOUNT ;{
                                 ;2 Bytes: Effect Code For this index (-1 = Empty)
                                 effcod = PeekW(markernum)
                                 markernum + 2
                                 ;2 Bytes: Effect Value For this index (-1 = Empty)
                                 effval = PeekW(markernum)
                                 markernum + 2
                                 Select effcod
                                     
                                     
                                   ;- THIS EFFECT read
                                   Case $03 ; follow
                                     If effval > 0
                                       FullPattern(matrind)\channel[chan]\efcd = $03
                                       FullPattern(matrind)\channel[chan]\efvl = effval
                                       note = 200 ; glue all durations to one note as volume do
                                     EndIf
                                     
                                     
                                   Case $08 ;{ stereo
                                     ; 0801 or 0810 (right and left, respectively)
                                     ; 0800=back To mono
                                     Select effval                                       
                                       Case 0, -1, $11
                                         objstereo = 0
                                       Case $10
                                         objstereo = $10
                                       Case 1
                                         objstereo = 1
                                     EndSelect
                                     ;}
                                   Case $01, $02 ;{ 1xx 2xx - Portamento Up & Down
                                     If effval > 0 
                                       If note And note < 100
                                         FullPattern(matrind)\channel[chan]\efcd = effcod
                                         FullPattern(matrind)\channel[chan]\efvl = effval
                                       EndIf
                                     EndIf
                                     ;}
                                   Case $E1, $E2 ;{ E1xy - Note Slide Up
                                     If effval > 0
                                       If note And note < 100
                                         FullPattern(matrind)\channel[chan]\efcd = effcod
                                         FullPattern(matrind)\channel[chan]\efvl = effval
                                       EndIf
                                     EndIf
                                     ;}
                                   Case $0B
                                     ; loop
                                     LOOPMARKER = matrix;effval
                                 EndSelect
                                 ;}
                               Next                               
                               
                               ;2 Bytes: Instrument For this index (-1 = Empty)
                               instrument = PeekW(markernum) : markernum + 2
                               instrument + 1 ; this +1 will make empty case "-1" to 0
                               
                               
                               If note
                                 Select note
                                   Case 100 
                                     If oldnote = 100
                                       ; double off. kill second off
                                       note = 0
                                       octv = 0
                                       ; volume too
                                       volm = 0
                                     ElseIf oldnote
                                       ; ElseIf oldnote - when channel no have any event, 
                                       If oldnote = 200
                                         FullPattern(oldvolmadd)\channel[chan]\duration + oldduration
                                       Else
                                         FullPattern(oldnoteadd)\channel[chan]\duration = oldduration
                                       EndIf
                                       oldnote = note
                                     EndIf
                                   
                                   Case 200
                                     ; fade in, fade out. and probably glue 03 effect durations
                                     FullPattern(oldvolmadd)\channel[chan]\duration + oldduration
                                     FullPattern(oldnoteadd)\channel[chan]\delay = oldduration
                                     oldduration = 0
                                     oldnoteadd = matrind
                                     
                                     oldnote = note
                                     
                                   Default
                                     If oldnote
                                       ; if old note is exists
                                       ; add to duration of old note new duration
                                       If oldnote = 200
                                         ; fade out fade in case
                                         FullPattern(oldvolmadd)\channel[chan]\duration + oldduration
                                       Else
                                         If FullPattern(oldnoteadd)\channel[chan]\duration = 0
                                           FullPattern(oldnoteadd)\channel[chan]\duration = oldduration
                                         EndIf
                                       EndIf
                                       FullPattern(oldnoteadd)\channel[chan]\delay    = oldduration
                                       oldduration = 0
                                       
                                       oldnote     = note
                                       oldnoteadd  = matrind
                                       oldvolmadd  = matrind
                                       
                                     Else
                                       ; intro - first note
                                       FullPattern(oldnoteadd)\channel[chan]\delay    = oldduration
                                       oldduration = 0
                                     
                                       oldnote     = note
                                       oldnoteadd  = matrind
                                       oldvolmadd  = matrind
                                     
                                     EndIf
                                     
                                     o3duration = 0 ; сброс 03 эффектного счетчика при старте какой-либо ноты
                                   
                                 EndSelect                                 
                               EndIf
                               
                               
                               
                               
                               If instrument                                 
                                 ; add instruments into array and clone, if it have some stereo effect
                                 tmp = GEMSInstrumentsStore(instrument, objstereo, IstrQuant)
                                 instrument = tmp & $FF ;: Debug instrument
                                 IstrQuant = tmp >> 8
                                 FullPattern(matrind)\channel[chan]\inst = instrument                              
                               EndIf
                               
                               If note And note <> 100
                                 ; 100 is note off for Deflemask.
                                 ; GEMS no have it.
                                 FullPattern(matrind)\channel[chan]\note = note
                               EndIf
                               
                               If octv And note <> 100
                                 FullPattern(matrind)\channel[chan]\octv = octv
                               EndIf
                               
                               If volm <> -1
                                 FullPattern(matrind)\channel[chan]\volm = volm
                               EndIf
                               
                               matrind + 1 ; 
                               oldduration + 1
                               o3duration + 1
                               
                               ;}
                             Next
                               
                               
                           Next   
                           
                           ; end of channel - need to define last notes
                           If oldduration ;And oldnoteadd
                             ;Debug "chan = " + Str(chan)
                             ;Debug "oldduration = " + Str(oldduration) + ", oldnote = " + Str(oldnote)
                             Select oldnote
                               Case 100 
                               Case 200
                                 FullPattern(oldvolmadd)\channel[chan]\duration + oldduration
                               Default
                                 FullPattern(oldnoteadd)\channel[chan]\duration = oldduration
                             EndSelect
                             FullPattern(oldnoteadd)\channel[chan]\delay = oldduration
                           EndIf
                           
                           
                         Next                         
                         ;}
                         
                         ; comments flags
                         notcomm = 1
                         rowcomm = 0
                         modcomm = 1
                         patcomm = 1
                       
                       If CreateFile(0, gemssaveto$ + "099.code")
                           
                           WriteStringN(0, "SECTION HEADER", #PB_Ascii)
                           WriteStringN(0, " dc.b 6", #PB_Ascii)
                           WriteStringN(0, " dc.t channel_0", #PB_Ascii)
                           WriteStringN(0, " dc.t channel_1", #PB_Ascii)
                           WriteStringN(0, " dc.t channel_2", #PB_Ascii)
                           WriteStringN(0, " dc.t channel_3", #PB_Ascii)
                           WriteStringN(0, " dc.t channel_4", #PB_Ascii)
                           WriteStringN(0, " dc.t channel_5", #PB_Ascii)
                           WriteStringN(0, "", #PB_Ascii)
                           
                         For chan = 1 To 6
                             
                           dmfpatternnum  = 0
                           dmfrownum      = 1
                             
                           gemsobjdelay.w = -1
                           gemsobjdurat.w = -1 
                           gemsobjinstr.w = -1
                           gemsobjvolum.w = -1
                           
                           WriteStringN(0, "channel_" + Str(chan-1) + ":", #PB_Ascii)
                           
                           If chan-1 = 0
                             ; first channel. it need master volume and tempo
                             WriteStringN(0, " delay 0", #PB_Ascii)
                             WriteStringN(0, " mastervolume 1", #PB_Ascii)
                             WriteStringN(0, " tempo " + Str(dmftorrrbpm), #PB_Ascii)
                             gemsobjdelay = 0
                           EndIf
                           
                           For row = 0 To ArraySize(FullPattern())
                             
                             modcomm$ = "" 
                             comment$ = ""
                             If rowcomm
                               comment$ + " ; " + Str(row)
                             EndIf
                             
                             
                             If FullPattern(row)\channel[chan]\inst And gemsobjinstr <> FullPattern(row)\channel[chan]\inst
                               If gemsobjdelay <> 0
                                 WriteStringN(0, " delay 0", #PB_Ascii)
                                 gemsobjdelay = 0
                               EndIf
                               WriteStringN(0, " patch patch_" + RSet(Hex(FullPattern(row)\channel[chan]\inst), 2, "0") + comment$, #PB_Ascii)
                               gemsobjinstr = FullPattern(row)\channel[chan]\inst
                             EndIf
                             
                             If FullPattern(row)\channel[chan]\volm And gemsobjvolum <> FullPattern(row)\channel[chan]\volm
                               If gemsobjdelay <> 0
                                 WriteStringN(0, " delay 0", #PB_Ascii)
                                 gemsobjdelay = 0
                               EndIf
                               vlmvalue = 127 - FullPattern(row)\channel[chan]\volm
                               If vlmvalue = 0
                                 vlmvalue = 1
                               EndIf
                               WriteStringN(0, " volume " + Str(vlmvalue) + comment$, #PB_Ascii)
                               gemsobjvolum = FullPattern(row)\channel[chan]\volm
                             EndIf
                             
                             If FullPattern(row)\channel[chan]\efcd
                               modnum = 0
                               Select FullPattern(row)\channel[chan]\efcd
                                 Case $01 ;{ Portamento Up
                                   ; speed * 6... probably
                                   moddur = FullPattern(row)\channel[chan]\duration * 3
                                   modspd = FullPattern(row)\channel[chan]\efvl * 6
                                   If moddur And modspd
                                     modnum = GEMSGetModulation(moddur, modspd)
                                   EndIf
                                   ;}
                                 Case $02 ;{ Portamento Down
                                   ; speed * 6... probably
                                   moddur = FullPattern(row)\channel[chan]\duration * 3
                                   modspd = FullPattern(row)\channel[chan]\efvl * 6 * -1
                                   If moddur And modspd
                                     modnum = GEMSGetModulation(moddur, modspd)
                                   EndIf    
                                   ;}
                                 Case $E1 ;{ Up
                                   ; xy - х speed, у high
                                   xspd = FullPattern(row)\channel[chan]\efvl >> 4
                                   yhgh = FullPattern(row)\channel[chan]\efvl & $F
                                   If xspd And yhgh
                                     ; only if both params is exist
                                     xspdd.d = xspd / 3    ; 1 deflemask's row = 3 GEMS's delays
                                     moddur = yhgh / xspdd 
                                     If moddur < 1
                                       ; if it is less than 1
                                       moddur = 1
                                     EndIf
                                     modspd = Round(xspdd * $100, #PB_Round_Up) ; pitch $100 is make note up to 1 note
                                     If moddur And modspd
                                       ; it have duration
                                       ; check that duration for a case, when modulation is shorter, than duration
                                       ; in that case it need to add 0 speed with second counter into modulation file
                                       If moddur < FullPattern(row)\channel[chan]\duration * 3
                                         modnum = GEMSGetModulation(moddur, modspd, (FullPattern(row)\channel[chan]\duration * 3) - moddur, 0)
                                       Else
                                         modnum = GEMSGetModulation(moddur, modspd)
                                       EndIf
                                     EndIf 
                                   EndIf 
                                   ;}
                                 Case $E2 ;{ Down
                                   ; xy - х speed, у high
                                   xspd = FullPattern(row)\channel[chan]\efvl >> 4
                                   yhgh = FullPattern(row)\channel[chan]\efvl & $F
                                   If xspd And yhgh
                                     xspdd.d = xspd / 3
                                     moddur = yhgh / xspdd
                                     If moddur < 1
                                       moddur = 1
                                     EndIf
                                     modspd = Round(xspdd * $100, #PB_Round_Up)
                                     If moddur And modspd
                                       ; it have duration
                                       ; check that duration for a case, when modulation is shorter, than duration
                                       ; in that case it need to add 0 speed with second counter into modulation file
                                       If moddur < FullPattern(row)\channel[chan]\duration * 3
                                         modnum = GEMSGetModulation(moddur, modspd * -1, (FullPattern(row)\channel[chan]\duration * 3) - moddur, 0)
                                       Else
                                         modnum = GEMSGetModulation(moddur, modspd * -1)
                                       EndIf
                                     EndIf
                                   EndIf                                   
                                   ;}
                                 Case $03 ;{ now it is only comments
                                   ;- THIS EFFECT write
                                   If modcomm
                                     modcomm$ = " ; it need 03 mod with " + Str(FullPattern(row)\channel[chan]\efvl)
                                   EndIf
                                   ;}
                               EndSelect
                               
                               If modnum
                                 If gemsobjdelay <> 0
                                   WriteStringN(0, " delay 0", #PB_Ascii)
                                   gemsobjdelay = 0
                                 EndIf
                                 WriteStringN(0, " modulation modulation_" + RSet(Hex(modnum), 2, "0") + comment$, #PB_Ascii)
                               EndIf
                               
                             EndIf
                             
                             If FullPattern(row)\channel[chan]\duration
                               If gemsobjdurat <> FullPattern(row)\channel[chan]\duration 
                                 WriteStringN(0, " duration " + Str(FullPattern(row)\channel[chan]\duration * 3) + comment$, #PB_Ascii)
                                 gemsobjdurat = FullPattern(row)\channel[chan]\duration
                               EndIf
                             EndIf
                             
                             If FullPattern(row)\channel[chan]\delay
                               If gemsobjdelay <> FullPattern(row)\channel[chan]\delay
                                 WriteStringN(0, " delay " + Str(FullPattern(row)\channel[chan]\delay * 3) + comment$, #PB_Ascii)
                                 gemsobjdelay = FullPattern(row)\channel[chan]\delay
                               EndIf
                               If FullPattern(row)\channel[chan]\note = 0
                                 ; without note - nop
                                 WriteStringN(0, " nop" + modcomm$, #PB_Ascii)
                               EndIf
                             EndIf
                             
                             If FullPattern(row)\channel[chan]\note And FullPattern(row)\channel[chan]\note <> 100
                               
                               If notcomm
                                 comment$ + " ; " + GetDMFNote(FullPattern(row)\channel[chan]\note) + Str(FullPattern(row)\channel[chan]\octv)
                               EndIf
                               
                               If FullPattern(row)\channel[chan]\note = 200
                                 WriteStringN(0, " nop" + modcomm$, #PB_Ascii)
                               Else
                                 note = FullPattern(row)\channel[chan]\note + FullPattern(row)\channel[chan]\octv * 12
                                 WriteStringN(0, " note $" + RSet(Hex(note), 2, "0") + comment$, #PB_Ascii)
                               EndIf                               
                             EndIf
                             
                             dmfrownum + 1
                             If dmfrownum = TOTALROWSPERP + 1
                               dmfrownum = 1
                               dmfpatternnum + 1
                               If patcomm
                                 WriteStringN(0, "; pattern " + RSet(Hex(dmfpatternnum), 2, "0"), #PB_Ascii)
                               EndIf
                             EndIf
                             
                           Next
                           
                           ; end of channel
                           WriteStringN(0, " eos", #PB_Ascii)
                           
                         Next
                         
                         CloseFile(0)
                       EndIf  

                       If EnableFileWrite
                         
                         ; file config
                         If CreateFile(#DFMCodeFile, gemssaveto$ + "099.cfg") ;{
                           WriteStringN(#DFMCodeFile, "code '099.code'", #PB_Ascii)
                           WriteStringN(#DFMCodeFile, "", #PB_Ascii)
                           
                           ; instruments
                           For i = 1 To ArraySize(DFMCfgInstrumList()) ;{
                             If DFMCfgInstrumList(i)\stereo = 0
                               ; as is
                               
                               index$   = RSet(Hex(DFMCfgInstrumList(i)\num), 2, "0")
                               nameins$ = "patch_" + index$ + ".ins"
                               nameraw$ = "patch_" + index$ + ".raw"
                               
                               WriteStringN(#DFMCodeFile, "instrument patch_" + RSet(Hex(DFMCfgInstrumList(i)\num), 2, "0") + ",'patch_" + RSet(Hex(DFMCfgInstrumList(i)\num), 2, "0") + ".ins'", #PB_Ascii) 
                               
                               ; file of instrument
                               If CreateFile(#File, gemssaveto$ + nameraw$)
                                 
                                 For raw = 1 To 39
                                   WriteAsciiCharacter(#File, GEMSInstrPack(DFMCfgInstrumList(i)\num)\raw[raw])
                                 Next
                                 
                                 CloseFile(#File)
                                 Delay(5)
                                 
                                 ; file-header
                                 If CreateFile(#DFMInsFile, gemssaveto$ + nameins$)
                                   WriteStringN(#DFMInsFile, "importraw '" + nameraw$ + "'", #PB_Ascii)
                                   CloseFile(#DFMInsFile)
                                   Delay(5)                                 
                                 EndIf
                                 
                               EndIf
                             Else
                               ; stereo changing
                               index$   = RSet(Hex(DFMCfgInstrumList(i)\newnum), 2, "0")
                               nameins$ = "patch_" + index$ + ".ins"
                               nameraw$ = "patch_" + index$ + ".raw"
                               
                               WriteStringN(#DFMCodeFile, "instrument patch_" + RSet(Hex(DFMCfgInstrumList(i)\newnum), 2, "0") + ",'patch_" + RSet(Hex(DFMCfgInstrumList(i)\newnum), 2, "0") + ".ins'", #PB_Ascii)
                               
                               ; file of instrument
                               If CreateFile(#File, gemssaveto$ + nameraw$)
                                 
                                 For raw = 1 To 4
                                   WriteAsciiCharacter(#File, GEMSInstrPack(DFMCfgInstrumList(i)\num)\raw[raw])
                                 Next
                                 
                                 Number = GEMSInstrPack(DFMCfgInstrumList(i)\num)\raw[5]
                                 Select DFMCfgInstrumList(i)\stereo
                                   Case $10
                                     SetBit(Number, NumToBit(7))
                                     ClearBit(Number, NumToBit(6))
                                   Case $01
                                     SetBit(Number, NumToBit(6))
                                     ClearBit(Number, NumToBit(7))
                                 EndSelect
                                 WriteAsciiCharacter(#File, Number)
                                 
                                 For raw = 6 To 39
                                   WriteAsciiCharacter(#File, GEMSInstrPack(DFMCfgInstrumList(i)\num)\raw[raw])
                                 Next
                                 
                                 CloseFile(#File)
                                 Delay(5)
                                 
                                 ; file-header
                                 If CreateFile(#DFMInsFile, gemssaveto$ + nameins$)
                                   WriteStringN(#DFMInsFile, "importraw '" + nameraw$ + "'", #PB_Ascii)
                                   CloseFile(#DFMInsFile)
                                   Delay(5)                                 
                                 EndIf
                                 
                               EndIf
                               
                             EndIf
                             ;}
                           Next
                           
                           WriteStringN(#DFMCodeFile, "", #PB_Ascii)
                           
                           ; modulations
                           sz = ArraySize(GEMSModulations())
                           If sz ;{
                             For i = 1 To sz
                               
                               index$ = RSet(Hex(i), 2, "0")
                               namemod$ = "modulation_" + index$ + ".mod"
                               
                               If CreateFile(#File, gemssaveto$ + namemod$)
                                 
                                 ; starting pitch
                                 WriteWord(#File, 0)
                                 
                                 sz2 = ArraySize(GEMSModulations(i)\modperiod())
                                 For m = 1 To sz2
                                   WriteAsciiCharacter(#File, GEMSModulations(i)\modperiod(m)\moddur)
                                   WriteWord(#File, GEMSModulations(i)\modperiod(m)\modspd)
                                 Next
                                 
                                 ; ending 0
                                 WriteAsciiCharacter(#File, 0)
                                 
                                 ; add string into main header of melody
                                 WriteStringN(#DFMCodeFile, "modulation modulation_" + index$ + ",'modulation_" + index$ + ".mod'", #PB_Ascii)
                                 
                                 CloseFile(#File)
                                 
                               EndIf
                               
                             Next
                             
                             WriteStringN(#DFMCodeFile, "", #PB_Ascii)
                             
                             ;}
                           EndIf
                           
                           ;}
                         EndIf
          
                         
                       EndIf
                       
                       
                       
                       
                     
                     
                     EndIf ; error = 0 
                     
                     
                   Else
                      MessageRequester("error", "something wrong with unpacking Deflemask's file.")
                   EndIf ; deflemask check
                   
                 EndIf ; unpack
                 
               Else
                 MessageRequester("error", "you didnt set path to input or output file.")
               EndIf ; paths
                 
             ;}
             










; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 895
; FirstLine = 380
; Folding = +Ao6dD-
; EnableXP