﻿CompilerIf #PB_Compiler_Version < 550
  CompilerSelect #PB_Compiler_OS
    CompilerCase #PB_OS_Windows
      #MR_ICONWARNING       = #MB_ICONWARNING
      #MR_ICONERROR         = #MB_ICONERROR
      #MR_ICONINFORMATION   = #MB_ICONINFORMATION
    CompilerDefault
      #MR_ICONWARNING       = #Null
      #MR_ICONERROR         = #Null
      #MR_ICONINFORMATION   = #Null
  CompilerEndSelect
CompilerElse
  #MR_ICONWARNING           = #PB_MessageRequester_Warning
  #MR_ICONERROR             = #PB_MessageRequester_Error
  #MR_ICONINFORMATION       = #PB_MessageRequester_Info
CompilerEndIf

#Z_NO_FLUSH                                         = 0
#Z_PARTIAL_FLUSH                                    = 1
#Z_SYNC_FLUSH                                       = 2
#Z_FULL_FLUSH                                       = 3
#Z_FINISH                                           = 4
#Z_BLOCK                                            = 5
#Z_TREES                                            = 6

#Z_OK                                               = 0
#Z_STREAM_END                                       = 1
#Z_NEED_DICT                                        = 2
#Z_ERRNO                                            = (-1)
#Z_STREAM_ERROR                                     = (-2)
#Z_DATA_ERROR                                       = (-3)
#Z_MEM_ERROR                                        = (-4)
#Z_BUF_ERROR                                        = (-5)
#Z_VERSION_ERROR                                    = (-6)

#Z_DEFAULT_COMPRESSION                              = (-1)
#Z_NO_COMPRESSION                                   = 0
#Z_BEST_SPEED                                       = 1
#Z_BEST_COMPRESSION                                 = 9

#Z_DEFAULT_STRATEGY                                 = 0
#Z_FILTERED                                         = 1
#Z_HUFFMAN_ONLY                                     = 2
#Z_RLE                                              = 3
#Z_FIXED                                            = 4

#Z_BINARY                                           = 0
#Z_TEXT                                             = 1
#Z_ASCII                                            = #Z_TEXT
#Z_UNKNOWN                                          = 2

#Z_NULL                                             = 0
#Z_DEFLATED                                         = 8

#MAX_MEM_LEVEL                                      = 9
#MAX_WBITS                                          = 15
#GZIP_ENCODING                                      = 16

#OS_FAT                                             = 0
#OS_AMIGA                                           = 1
#OS_VMS                                             = 2
#OS_UNIX                                            = 3
#OS_VM_CMS                                          = 4
#OS_ATARI_TOS                                       = 5
#OS_HPFS                                            = 6
#OS_MACINTOSH                                       = 7
#OS_Z_SYSTEM                                        = 8
#OS_CP_M                                            = 9
#OS_TOPS_20                                         = 10
#OS_NTFS                                            = 11
#OS_QDOS                                            = 12
#OS_ACORN_RISCOS                                    = 13
#OS_UNKNOWN                                         = 255

#ZLIB_VERSION                                       = "1.2.8"
#CHUNK_SIZE                                         = 1024 * 256

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_Windows
    Macro INTEGER : l : EndMacro : #ZLIB_IMPORT = "zlib.lib"
  CompilerCase #PB_OS_MacOS
    Macro INTEGER : i : EndMacro : #ZLIB_IMPORT = "-lz"
  CompilerCase #PB_OS_Linux
    Macro INTEGER : i : EndMacro : #ZLIB_IMPORT = "zlib.a"
CompilerEndSelect

Structure Z_STREAM Align #PB_Structure_AlignC
  *next_in.BYTE
  avail_in.l
  total_in.INTEGER
  *next_out.BYTE
  avail_out.l
  total_out.INTEGER
  *msg.BYTE
  *state
  *zalloc
  *zfree
  *opaque
  data_type.INTEGER
  adler.INTEGER
  reserved.INTEGER
EndStructure

Structure GZ_HEADER Align #PB_Structure_AlignC
  text.l
  time.INTEGER
  xflags.l
  os.l
  *extra.BYTE
  extra_len.l
  extra_max.l
  *name.BYTE
  name_max.l
  *comment.BYTE
  comm_max.l
  hcrc.l
  done.l
EndStructure

CompilerSelect #PB_Compiler_OS
  CompilerCase #PB_OS_MacOS
    Import "-stdlib=libc++ -mmacosx-version-min=10.7" : EndImport
CompilerEndSelect

ImportC #ZLIB_IMPORT
  deflate(*stream, flush)
  deflateBound(*stream, sourceLen)
  deflateEnd(*stream)
  deflateInit2_(*stream, level, method, windowBits, memLevel, strategy, version.p-ascii, strm_size)
  deflateSetHeader(*stream, *head)
  inflate(*stream, flush)
  inflateEnd(*stream)
  inflateGetHeader(*stream, *head)
  inflateInit2_(*stream, windowBits, version.p-ascii, strm_size)
  inflateReset(*stream)
EndImport

Procedure Deflate_Initialize(*stream.Z_STREAM, windowBits)
  *stream\zalloc = #Z_NULL
  *stream\zfree = #Z_NULL
  *stream\opaque = #Z_NULL
  *stream\data_type = #Z_BINARY
  deflateInit2_(*stream, #Z_DEFAULT_COMPRESSION, #Z_DEFLATED, windowBits, #MAX_MEM_LEVEL, #Z_DEFAULT_STRATEGY, #ZLIB_VERSION, SizeOf(Z_STREAM))
EndProcedure

Procedure Deflate_SetHeader(*stream.Z_STREAM, *header.GZ_HEADER)
  HeaderExtra.s = "This is an Extra field by JHPJHP." + Chr(0)
  nLength = StringByteLength(HeaderExtra, #PB_Ascii)
  *header\extra = AllocateMemory(nLength + 1)
  HeaderName.s = "Original_Filename.jhp" + Chr(0)
  *header\name = AllocateMemory(StringByteLength(HeaderName, #PB_Ascii) + 1)
  HeaderComment.s = "This is a comment by JHPJHP." + Chr(0)
  *header\comment = AllocateMemory(StringByteLength(HeaderComment, #PB_Ascii) + 1)
  *header\text = #Z_NULL
  *header\time = Date() + 60 * 60 * 4
  *header\xflags = #Z_NULL
  *header\os = #OS_NTFS

  If *header\extra : PokeS(*header\extra, HeaderExtra, -1, #PB_Ascii) : EndIf

  *header\extra_len = nLength
  *header\extra_max = #Z_NULL

  If *header\name : PokeS(*header\name, HeaderName, -1, #PB_Ascii) : EndIf

  *header\name_max = #Z_NULL

  If *header\comment : PokeS(*header\comment, HeaderComment, -1, #PB_Ascii) : EndIf

  *header\comm_max = #Z_NULL
  *header\hcrc = #Z_NULL
  *header\done = #Z_NULL
  deflateSetHeader(*stream, *header)
EndProcedure

Procedure Deflate_Payload(*payload, nLength)
  *stream.Z_STREAM = AllocateMemory(SizeOf(Z_STREAM))
  *header.GZ_HEADER = AllocateMemory(SizeOf(GZ_HEADER))
  Deflate_Initialize(*stream, 15 | #GZIP_ENCODING)
  Deflate_SetHeader(*stream, *header)
  *stream\next_in = *payload
  *stream\avail_in = nLength
  *output = AllocateMemory(#CHUNK_SIZE)

  Repeat
    *stream\avail_out = #CHUNK_SIZE
    *stream\next_out = *output
    deflate(*stream, #Z_FINISH)
    nOut = (#CHUNK_SIZE - *stream\avail_out)
    nSize + nOut

    If nSize = 0 : Break : EndIf

    *deflate = ReAllocateMemory(*deflate, nSize)
    CopyMemory(*output, *deflate + nStart, nOut)
    nStart + nOut
  Until *stream\avail_out <> 0
  deflateEnd(*stream)
  FreeMemory(*header)
  FreeMemory(*stream)
  ProcedureReturn *deflate
EndProcedure

Procedure Inflate_Initialize(*stream.Z_STREAM, windowBits)
  *stream\zalloc = #Z_NULL
  *stream\zfree = #Z_NULL
  *stream\opaque = #Z_NULL
  *stream\data_type = #Z_BINARY
  inflateInit2_(*stream, windowBits, #ZLIB_VERSION, SizeOf(Z_STREAM))
EndProcedure

Procedure Inflate_GetHeader(*stream.Z_STREAM, *header.GZ_HEADER)
  inflateGetHeader(*stream, *header)
EndProcedure

Procedure Inflate_Payload(*payload, nLength, indinitb.a=16)
  *stream.Z_STREAM = AllocateMemory(SizeOf(Z_STREAM))
  *header.GZ_HEADER = AllocateMemory(SizeOf(GZ_HEADER))
  *header\extra_max = 50 : *header\extra = AllocateMemory(*header\extra_max + 1)
  *header\name_max = 50 : *header\name = AllocateMemory(*header\name_max + 1)
  *header\comm_max = 50 : *header\comment = AllocateMemory(*header\comm_max + 1)
  Inflate_Initialize(*stream, indinitb | #MAX_WBITS)
  Inflate_GetHeader(*stream, *header)
  *stream\next_in = *payload
  *stream\avail_in = nLength
  *output = AllocateMemory(#CHUNK_SIZE)

  Repeat
    *stream\avail_out = #CHUNK_SIZE
    *stream\next_out = *output
    inflate(*stream, #Z_FINISH)
    nOut = (#CHUNK_SIZE - *stream\avail_out)
    nSize + nOut

    If nSize = 0 : Break : EndIf

    *inflate = ReAllocateMemory(*inflate, nSize)
    CopyMemory(*output, *inflate + nStart, nOut)
    nStart + nOut
  Until *stream\avail_out <> 0

  If *header\done = 1
    Debug "text: " + *header\text
    Debug "time: " + *header\time
    Debug "xflags: " + *header\xflags
    Debug "os: " + *header\os

    If *header\extra : Debug "extra: " + PeekS(*header\extra, -1, #PB_Ascii) : EndIf

    Debug "extra_len: " + *header\extra_len
    Debug "extra_max: " + *header\extra_max

    If *header\name : Debug "name: " + PeekS(*header\name, -1, #PB_Ascii) : EndIf

    Debug "name_max: " + *header\name_max

    If *header\comment : Debug "comment: " + PeekS(*header\comment, -1, #PB_Ascii) : EndIf

    Debug "comm_max: " + *header\comm_max
    Debug "hcrc: " + *header\hcrc
    Debug "done: " + *header\done
  EndIf
  deflateEnd(*stream)
  FreeMemory(*header)
  FreeMemory(*stream)
  ProcedureReturn *inflate
EndProcedure


; IDE Options = PureBasic 5.60 (Windows - x86)
; CursorPosition = 214
; FirstLine = 200
; Folding = --
; EnableXP